package org.greenstone.gatherer.gui.messages;
/**
 *#########################################################################
 *
 * A component of the Gatherer application, part of the Greenstone digital
 * library suite from the New Zealand Digital Library Project at the
 * University of Waikato, New Zealand.
 *
 * <BR><BR>
 *
 * Author: John Thompson, Greenstone Digital Library, University of Waikato
 *
 * <BR><BR>
 *
 * Copyright (C) 1999 New Zealand Digital Library Project
 *
 * <BR><BR>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * <BR><BR>
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * <BR><BR>
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *########################################################################
 */
import java.util.Hashtable;
import java.util.Vector;
/**
 * @author John Thompson, Greenstone Digital Library, University of Waikato
 * @version 1.1
 */ 
import javax.swing.AbstractListModel;
import org.greenstone.gatherer.Gatherer;
import org.greenstone.gatherer.Message;
import org.greenstone.gatherer.util.Utility;
class MessageListModel 
    extends AbstractListModel {

    Hashtable mappings;

    int current_index;

    int current_message;

    int sizes[][] = new int[6][4];

    Vector data;

    // Contructor
    public MessageListModel() {
	current_index = 0;
	current_message = 0;
	data = new Vector();
	mappings = new Hashtable();
	for(int i = 0; i < 6; i++) {
	    for(int j = 0; j < 4; j++) {
		sizes[i][j] = 0;
	    }
	}
    }
    
    // Add a new message in the correct place
    public synchronized void add(Message message) {
	// Add the element to the model
	data.add(message);
	// Increment the count for that type of message
	sizes[message.source][message.level]++;
	// An announce to the world that I have changed!
        fireContentsChanged(this, 0, getSize() - 1);
    }

    // Return the size of the list
    public int getSize() {
	int size = 0;
	// Each each source...
	for(int i = 0; i < 6; i++) {
				// and each level...
	    for(int j = 0; j < 4; j++) {
		// If both this source and level are active, add its size
		/** @todo reenabled 
		 * if(gatherer.config.source[i] && gatherer.config.level[j]) {
		 *	size = size + sizes[i][j];
		 * }
		 */
	    }
	}
	return size;
    }

    public int getTotalSize() {
	int size = 0;
	// Each each source...
	for(int i = 0; i < 6; i++) {
				// and each level...
	    for(int j = 0; j < 4; j++) {
		size = size + sizes[i][j];
	    }
	}
	return size;
    }

    public String getSizeStr() {
	return "" + getSize() + "";
    }

    public String getTotalSizeStr() {
	return "" + getTotalSize() + "";
    }

    // Return a message from the list
    public Object getElementAt( int index ) {
	Integer index_int = new Integer(index);
	// Maybe we've already found this message.
	if(mappings.containsKey(index_int)) {
	    current_message = ((Integer)mappings.get(index_int)).intValue();
	}
	// Otherwise we're going to have to search for it.
	else {
	    while(index != current_index) {
		// Asking for an index lower than the one we're at.
		if(index < current_index) {
		    Message temp;
		    /*
		      do {
		      current_message--;
		      temp = (Message)data.get(current_message);
		      } while(!(gatherer.config.source[temp.source] && 
		      gatherer.config.level[temp.level]));
		      // We are now at a new visible message.
		    */
		    current_index--;
		}
		else {
		    Message temp;
		    /*
		      do {
		      current_message++;
		      temp = (Message)data.get(current_message);
		      } while(!(gatherer.config.source[temp.source] && 
		      gatherer.config.level[temp.level]));
		      // We are now at a new visible message.
		      current_index++;
		    */
		}
	    }
				// Now that we've found the blighter, add a mapping so its quicker
				// next time.
	    mappings.put(new Integer(index),new Integer(current_message));
	}
	return ((Message)data.get(current_message)).toString();
    }

    public void refresh() {
	if(getSize() > 0) {
	    current_index = 0;
				// Find the first message that meets the requirements. Its index 0 y'know.
	    current_message = -1;
	    Message temp;
				/*
				  do {
				  current_message++;
				  temp = (Message)data.get(current_message);
				  } while(!(gatherer.config.source[temp.source] && 
				  gatherer.config.level[temp.level]));	
				*/	
				// Reset mappings.
	    mappings.clear();
	    mappings.put(new Integer(current_index), new Integer(current_message));
				// Let everyone who cares know we've changed.
	    fireContentsChanged(this, 0, getSize() - 1);
	}
	// Else don't bother doning anything on an empty list!
    }
}




