package org.greenstone.gsdl3.build;

public class GS2PerlListener 
    implements ConstructionListener {

    /** a buffer holding all the messages */
    protected StringBuffer log_=null;
    /** a buffer holding only the latest update */
    protected StringBuffer update_ = null;

    /** a status code */
    protected int status_ = -1;
    /** whether the process this is listeneing to is finshed */
    protected boolean finished_ = false;

    public GS2PerlListener() {
	log_ = new StringBuffer();
	update_ = new StringBuffer();
    }

    public boolean isFinished() {
	return finished_;
    }
    public String getLog() {
	return log_.toString();
    }
    public int getStatus() {
	return status_;
    }
    synchronized public String getUpdate() {
	log_.append(update_);
	String tmp = update_.toString();
	update_.delete(0, update_.length());
	return tmp;
    }

    // do we need to synchronize the methods below?

    /** This event handler used to signify that a task has been started */
    synchronized public void processBegun(ConstructionEvent evt) {
	status_ = evt.getStatus();
	update_.append(evt.getMessage()+"\n");
	
    }
    /** This event handler used to signify that a task has been completed */
    synchronized public void processComplete(ConstructionEvent evt){
	status_ = evt.getStatus();
	update_.append(evt.getMessage()+"\n");
    }
    /** This event handler used to send status updates as the task is progressing */
    synchronized public void processStatus(ConstructionEvent evt){
	status_ = evt.getStatus();
	update_.append(evt.getMessage()+"\n");
    }
    /**  This event handler used to send any other messages to the listeners */
    synchronized public void message(ConstructionEvent evt){
	status_ = evt.getStatus();
	update_.append(evt.getMessage()+"\n");
    }


}
